# Processing: Cast Remote Display API

This Google Cast sample application shows how to use the Remote Display API with Processing.

## Dependencies
* Processing 2.2.1 with Android Mode 0232
* google-play-services_lib library from the Android SDK (at least version 7.5.71)
* android-support-v7-appcompat (version 21 or above)
* android-support-v7-mediarouter (version 20 or above)

## Setup Instructions
* Create a new app ID for a Remote Display Receiver using the Google Cast SDK Developer Console: https://cast.google.com/publish/
* Add the app ID to the resources strings.xml file
* Use Gradle or Android Studio to build the app
* Run the app on your mobile device
* Select a Google Cast device as a remote display by clicking on the Cast button
* Use the mobile device touch screen to control the animation on the Google Cast device

## Additional Processing Apps
* Use the Processing 2.2.1 IDE Android Mode to export an Android project.
* Copy your exported Android project into this project's third_party directory.
* Modify the top-level build.gradle file to include your apps source code (java.srcDirs) and assets (assets.srcDirs).
* For each lib jar file add a 'compile' entry to the bottom of the build.gradle file (except processing-core.jar).
* Modify the top-level AndroidManifest.xml file to change the main Activity 'android:name' to the exported main activity class name.
* You might have to modify the original sketch setup if you run into any performance issues on the mobile device.

## References and How to report bugs
* Based on Processing 2.2.1 source code: https://github.com/processing/processing/archive/processing-0227-2.2.1.zip
* Based on Processing Android Mode source code: https://github.com/processing/processing-android/archive/android-232.zip
* Based on toxiclibs source code: https://bitbucket.org/postspectacular/toxiclibs/downloads/toxiclibs-complete-0020.zip
* Remote Display API: https://developers.google.com/cast/docs/remote
* This source code is released as-is and is not supported by Google.
* See PORT on how the Processing code was modified for this project.

## How to make contributions?
Contributions are not accepted to this code.

## License
See LICENSE

## Google+
Google Cast Developers Community on Google+ [http://goo.gl/TPLDxj](http://goo.gl/TPLDxj)
